;Program: Klavesnice
	LIST P = 16F84,	R = DEC
	#INCLUDE <P16F84.INC>
;---------------------------------------------------------------
	ORG	H'2100'
  __CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC
;***************************************************************
RAM	EQU	H'0C'
;---------------------------------------------------------------
KLAV1	EQU	10h
KLAV0	EQU	11h
TM0		EQU	RAM
TM1		EQU	RAM+1
TM2		EQU	RAM+2
TMP		EQU	RAM+3
TMP1	EQU	RAM+4
TMPKL	EQU	RAM+17
NUM		EQU	RAM+5
POCSTI	EQU	RAM+6			;pocitadlo stisku
KOD0	EQU	RAM+7
KOD00	EQU	RAM+8
KOD1	EQU	RAM+9
KOD11	EQU	RAM+10
KOD2	EQU	RAM+11
KOD22	EQU	RAM+12
KOD3	EQU	RAM+13
KOD33	EQU	RAM+14
KOD4	EQU	RAM+15
KOD44	EQU	RAM+16
POKUSY	EQU RAM+18
TMPW	EQU	RAM+19
TMPSTAT	EQU	RAM+20
STISKY	EQU	RAM+21
TMRES	EQU	RAM+22

;#define	Z	SWR,2
#define	PIEZO	PORTA,0		;piezo
#define	RELE	PORTA,1		;rele
#define	LEDC	PORTA,3		;cervena LED
#define	LEDZ	PORTA,2		;zelena LED

#define	COL3	PORTB,3		;pozor!v klavesnici s 4*3 tlacitky zustava nezapojeno(sloupec 3)
#define	COL2	PORTB,2		;sloupec2
#define	COL1	PORTB,1		;sloupec1
#define	COL0	PORTB,0		;sloupec0

#define	ROW3	PORTB,7		;radek3
#define	ROW2	PORTB,6		;radek2
#define	ROW1	PORTB,5		;radek1
#define	ROW0	PORTB,4		;radek0
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	ORG	0
	GOTO	START
	ORG	4
	GOTO	OBSPRERUS
;***************************************************************
t0.5ms	MOVLW	124
	MOVWF	TM1
	NOP
	DECFSZ	TM1,F
	GOTO	$-2
	RETURN
;***************************************************************
t1ms	MOVLW	248
	MOVWF	TM1
	NOP
	DECFSZ	TM1,F
	GOTO	$-2
	RETURN
;***************************************************************
t100mS	MOVLW	160		;doba 100 milisekund
	MOVWF	TM1
	MOVLW	207
	MOVWF	TM2
	DECFSZ	TM2,F
	GOTO	$-1
	DECFSZ	TM1,F
	GOTO	$-5
	RETURN
;***************************************************************
t500mS	CLRF	TM2		;doba 500 milisekund
	CLRF	TM1
	NOP
	DECFSZ	TM1,F
	GOTO	$-2
	NOP
	DECFSZ	TM1,F
	GOTO	$-2
	DECFSZ	TM2,F
	GOTO	$-7
	RETURN
;***************************************************************
t3s	MOVLW	30
	MOVWF	TM0
	MOVLW	198
	MOVWF	TM1
	MOVLW	167
	MOVWF	TM2
	DECFSZ	TM2,F
	GOTO	$-1
	DECFSZ	TM1,F
	GOTO	$-5
	DECFSZ	TM0,F
	GOTO	$-9
	RETURN
;***************************************************************
;Podprogram ulo data z registru NUM na adresu pamti EEPROM,kter
;bude uloen v registru W ped zavolnm podprogramu.
SAVE	MOVWF	EEADR		;obsah registru W do registru EEADR
	MOVFW	NUM
	MOVWF	EEDATA		;obsah registru NUM do registru EEDATA
	BSF	STATUS,RP0	;banka 1
	BSF	EECON1,WREN	;zpis do EEPROM povolen
	MOVLW	H'55'
	MOVWF	EECON2		;prvn zpis bezpenostnho kdu
	MOVLW	H'AA'
	MOVWF	EECON2		;druh zpis bezpenostnho kdu
	BSF	EECON1,WR
	BTFSS	EECON1,EEIF	;je zpis ukonen?
	GOTO	$-1		;ne,ekej
	BCF	EECON1,EEIF	;bit EEIF vynulovn
	BCF	EECON1,WREN	;zpis do EEPROM zakzn
	BCF	STATUS,RP0	;banka 0
	RETURN
;***************************************************************
;Podprogram zape do registru NUM data z adresy pamti EEPROM,kter
;byla ped zavolnm podprogramu nastavena v registru W.
LOAD	MOVWF	EEADR		;obsah registru W do registru EEADR
	BSF	STATUS,RP0	;banka 1
	BSF	EECON1,RD	;peti data
	BCF	STATUS,RP0	;banka 0
	MOVFW	EEDATA
	MOVWF	NUM		;zapi data do registru NUM
	RETURN
;***************************************************************
PIPNI	MOVLW	255		;KRATKE PIPNUTI
	MOVWF	TMP
	BCF		PIEZO		;ZAPNI REPRO	
	CALL	t0.5ms		;CEKEJ	1ms
	BSF		PIEZO		;VYPNI REPRO
	CALL	t0.5ms		;CEKEJ	1ms
	DECFSZ	TMP			;ODECTI 1 OD TMP, KDYZ TMP=0 PRESKOC GOTO $-7
	GOTO	$-5			;JDI o 5 instrukci zpet
	RETURN
;----------------------------------------------------------------
PIPOK	CALL	PIPNI
	BCF		PIEZO		;ZAPNI REPRO	
	CALL	t1ms		;CEKEJ	1ms
	BSF		PIEZO		;VYPNI REPRO
	CALL	t1ms		;CEKEJ	1ms
	DECFSZ	TMP			;odecti 1 od tmp, kdyz tmp=0 preskoc goto $-7
	GOTO	$-5			;jdi o 5 instrukci zpet
	RETURN
;***************************************************************


;*************************************************************
NASTAV	macro	PORTX,SETTING,OUTPUT
	BCF		STATUS,RP0
	MOVLW	OUTPUT
	MOVWF	PORTX
	BSF		STATUS,RP0
	MOVLW	SETTING
	MOVWF	PORTX
	BCF		STATUS,RP0
	endm
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
OBSPRERUS
	BCF		INTCON,GIE	;vsechna preruseni zakazana
	MOVWF	TMPW
	MOVFW	STATUS
	MOVWF	TMPSTAT	;zaloha W a STATUS
	BCF		INTCON,RBIF ;vynuluj priznak pozadavku preruseni od RB7-4
	
;-----
TLAC
	CALL	PIPNI
	DECFSZ	STISKY,1
	GOTO	KONECPRE
LED	BTFSS	TMP1,0
	GOTO	OFFLEDC		;zhasni LEDC	
	BCF		LEDC		;rozsvit LEDC
	BCF		RELE		;rozepni rele
	BSF		LEDZ
	BCF		TMP1,0
	BCF		TMRES,0
	MOVLW	D'4'
	MOVWF	STISKY
	CALL	PIPOK
	GOTO	KONECPRE
OFFLEDC	NOP
	BSF		LEDC
	BSF		RELE		;sepni rele
	BCF		LEDZ
	BSF		TMP1,0
	BCF		TMRES,0
	MOVLW	D'4'
	MOVWF	STISKY
	CALL	PIPOK
;-----
KONECPRE
	MOVFW	TMPSTAT
	MOVWF	STATUS
	MOVF	TMPW
SPAT
	MOVLW	B'10001000'
	MOVWF	INTCON		;povoleno preruseni pri zmene na PB4/PB7
	SLEEP
;***************************************************************
START	
	NASTAV	PORTA, B'00000000', B'00000000'	;portA vse vystupy, LED zhasnuty, RELE rozeple, PIEZO 0
	NASTAV	PORTB, B'11110000', B'00001111'	;portB 7/4 vstupy, portB3/0 vystupy (v 1)
	BCF		LEDC
	BCF		RELE		;-stav po zapnuti napajeni, rele rozeple, zastrezeno!
	BSF		TMP1,0		;pristim zadanim kodu bude rele sepnuto->NEzastrezeno
	BSF		LEDZ
	CALL	PIPOK
	CALL	PIPNI
	CLRF	POCSTI
	MOVLW	D'3'
	MOVWF	POKUSY
	MOVLW	D'4'
	MOVWF	STISKY
	MOVLW	B'10001000'
	MOVWF	INTCON		;povoleno preruseni pri zmene na PB4/PB7
	SLEEP
	END

